import * as React from 'react';
import * as _webbo_ui_theme from '@webbo-ui/theme';
import { Reason, RenderInputProps } from './autocomplete.js';
export { AutocompleteProps } from './autocomplete.js';
import { OptionProps } from './option.js';
export { mapInputProps } from './map-input-props.js';
import '@webbo-ui/popper';
import '@webbo-ui/input';

declare const Autocomplete: <Value extends object, Multiple extends boolean = false, DisableClearable extends boolean = false>(props: _webbo_ui_theme.AutocompleteVariantProps & Omit<React.HTMLAttributes<HTMLUListElement>, "children" | "defaultValue"> & {
    disabled?: boolean | undefined;
    classNames?: Omit<_webbo_ui_theme.ClassNames<{
        listbox: string;
        option: string;
        noOptions: string;
        loading: string;
        group: string;
        groupHeader: string;
        groupItems: string;
    }>, "option"> | undefined;
    offset?: number | undefined;
    options: Value[];
    isOpen?: boolean | undefined;
    onOpenChange?: ((open: boolean) => void) | undefined;
    defaultOpen?: boolean | undefined;
    getOptionDisabled?: ((option: Value) => boolean) | undefined;
    disableCloseOnSelect?: boolean | undefined;
    getOptionLabel?: ((option: Value) => string) | undefined;
    getOptionKey?: ((options: Value) => string) | undefined;
    noOptionsText?: string | undefined;
    loading?: boolean | undefined;
    loadingText?: string | undefined;
    groupBy?: ((option: Value) => string) | undefined;
    children?: ((props: {
        groupedOptions: Record<string, {
            option: Value;
            key: string;
            label: string;
            selected: boolean;
            disabled: boolean;
            focused: boolean;
            onSelect: () => void;
            onHover: () => void;
            id: string;
        }[]> | null;
        options: {
            option: Value;
            key: string;
            label: string;
            selected: boolean;
            disabled: boolean;
            focused: boolean;
            onSelect: () => void;
            onHover: () => void;
            id: string;
        }[] | null;
    }) => React.ReactNode) | undefined;
    inputValue?: string | undefined;
    onInputChange?: ((val: string) => void) | undefined;
    filterOptions?: ((options: Value[], inputValue: string) => Value[]) | undefined;
    portal?: boolean | undefined;
} & (Multiple extends true ? {
    multiple: Multiple;
    defaultValue?: Value[] | undefined;
    value?: Value[] | undefined;
    onChange?: ((event: {
        target: {
            value: Value[];
        };
    }, reason: Reason, value: Value[]) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
    renderInput: (props: RenderInputProps<Value[]>) => React.ReactNode;
} : DisableClearable extends true ? {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | undefined;
    onChange?: ((event: {
        target: {
            value: Value;
        };
    }, reason: Reason, value: Value) => void) | undefined;
    disableClearable: DisableClearable;
    renderInput: (props: RenderInputProps<Value>) => React.ReactNode;
} : {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | null | undefined;
    onChange?: ((event: {
        target: {
            value: Value | null;
        };
    }, reason: Reason, value: Value | null) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
    renderInput: (props: RenderInputProps<Value | null>) => React.ReactNode;
}) & React.RefAttributes<HTMLUListElement>) => React.ReactNode;
declare const Option: React.ForwardRefExoticComponent<OptionProps & {
    children?: React.ReactNode;
} & React.RefAttributes<HTMLLIElement>>;

export { Autocomplete, Option, OptionProps, Reason };
