"use client";
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Autocomplete: () => Autocomplete2,
  Option: () => Option2,
  mapInputProps: () => mapInputProps
});
module.exports = __toCommonJS(src_exports);

// src/autocomplete.tsx
var Popper = __toESM(require("@webbo-ui/popper"));
var import_use_controllable_state = require("@webbo-ui/use-controllable-state");
var import_error = require("@webbo-ui/error");

// src/option.tsx
var import_react_utils = require("@webbo-ui/react-utils");
var import_use_pointer_events = require("@webbo-ui/use-pointer-events");
var import_react = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var Option_Name = "Option";
var Option = import_react.default.forwardRef((props, ref) => {
  const {
    label,
    onSelect,
    onHover,
    disabled,
    focused,
    selected,
    children,
    id,
    className
  } = props;
  const styles = useStylesContext(Option_Name);
  const innerRef = import_react.default.useRef(null);
  const isHovered = import_react.default.useRef(false);
  const pointerEvents = (0, import_use_pointer_events.usePointerEvents)({
    onPointerDown: (e) => {
      e.preventDefault();
    },
    onPress: () => {
      if (disabled)
        return;
      onSelect();
    }
  });
  import_react.default.useEffect(() => {
    if (selected)
      innerRef.current?.scrollIntoView({
        behavior: "instant",
        block: "center"
      });
  }, [selected]);
  import_react.default.useEffect(() => {
    if (focused && !isHovered.current)
      innerRef.current?.scrollIntoView({
        behavior: "instant",
        block: "nearest"
      });
  }, [focused]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "li",
    {
      ref: (0, import_react_utils.mergeRefs)(ref, innerRef),
      onPointerEnter: () => {
        isHovered.current = true;
        onHover();
      },
      onPointerLeave: () => {
        isHovered.current = false;
      },
      className: styles.option({ className }),
      id,
      role: "option",
      "aria-selected": disabled ? void 0 : selected,
      "data-disabled": disabled,
      "data-selected": selected,
      "data-focused": focused,
      ...pointerEvents,
      children: children ?? label
    }
  );
});
Option.displayName = "webbo-ui." + Option_Name;

// src/autocomplete.tsx
var import_lodash = __toESM(require("lodash.groupby"));
var import_theme = require("@webbo-ui/theme");
var import_react_utils2 = require("@webbo-ui/react-utils");
var import_react2 = __toESM(require("react"));
var import_react_dom = require("react-dom");
var import_context = require("@webbo-ui/context");
var import_jsx_runtime2 = require("react/jsx-runtime");
var import_react3 = require("react");
var Autocomplete_Name = "Autocomplete";
var [StylesProvider, stylesHook] = (0, import_context.createContextScope)(Autocomplete_Name);
var useStylesContext = stylesHook;
var AutocompleteImp = import_react2.default.forwardRef((props, ref) => {
  const {
    classNames,
    className,
    offset,
    isOpen: openProp,
    onOpenChange,
    defaultOpen = false,
    defaultValue,
    value: valueProp,
    onChange,
    shadow = "md",
    options: optionsProp = [],
    disabled,
    multiple,
    disableClearable,
    disableCloseOnSelect,
    children,
    getOptionDisabled,
    noOptionsText = "no options",
    loading,
    loadingText = "loading ...",
    getOptionLabel: getOptionLabelProp,
    getOptionKey,
    groupBy,
    inputValue: inputValueProp,
    onInputChange: onInputChangeProp,
    filterOptions,
    renderInput,
    portal = true,
    ...restProps
  } = props;
  const getOptionLabel = (option) => {
    if (getOptionLabelProp) {
      return getOptionLabelProp(option);
    }
    if (!("label" in option))
      throw new import_error.CustomError(
        "Select",
        "consider to add `label` property in all options or use `getOptionLabel` prop to get option label"
      );
    return option.label;
  };
  const [value, setValue] = (0, import_use_controllable_state.useControllableState)({
    defaultValue,
    value: valueProp,
    onChange: (value2, reason) => {
      if (!reason)
        throw new import_error.CustomError(
          "Autocomplete",
          "internal Error, reason is not defined"
        );
      onChange?.({ target: { value: value2 } }, reason, value2);
    }
  });
  const inputDefaultValue = !Array.isArray(value) && value ? getOptionLabel(value) : "";
  const prevSelectedValue = import_react2.default.useRef(inputDefaultValue);
  const [inputValue, setInputValue] = (0, import_use_controllable_state.useControllableState)({
    defaultValue: inputDefaultValue,
    value: inputValueProp,
    onChange: onInputChangeProp
  });
  const [options, setOptions] = import_react2.default.useState(optionsProp);
  const groupedOptions = import_react2.default.useMemo(() => {
    if (!groupBy)
      return null;
    const grouped = (0, import_lodash.default)(options, (opt) => {
      const by = groupBy(opt);
      if (!isNaN(+by))
        return "0-9";
      return by;
    });
    return Object.entries(grouped).sort((a, b) => {
      const a_key = a[0];
      const b_key = b[0];
      if (a_key < b_key)
        return -1;
      if (a_key > b_key)
        return 1;
      return 0;
    }).reduce(
      (acc, ele) => (acc[ele[0]] = ele[1], acc),
      {}
    );
  }, [groupBy, options]);
  const inputRef = import_react2.default.useRef(null);
  const popperReferenceRef = import_react2.default.useRef(null);
  const [focused, setFocused] = import_react2.default.useState(null);
  const lisboxId = import_react2.default.useId();
  const [isOpen, setIsOpen] = (0, import_use_controllable_state.useControllableState)({
    defaultValue: defaultOpen ?? false,
    value: openProp,
    onChange: onOpenChange
  });
  const handleClose = () => {
    setIsOpen(false);
    setFocused(null);
    setOptions(optionsProp);
    if (Array.isArray(value))
      setInputValue("");
    if (prevSelectedValue.current !== inputValue)
      setInputValue(prevSelectedValue.current);
  };
  const onOpen = () => {
    if (isOpen)
      return;
    setIsOpen(true);
    if (!options.length)
      return;
    if (!value) {
      setFocused(getNext(options[0], options, getOptionDisabled));
      return;
    }
    setFocused(Array.isArray(value) ? value[0] : value);
  };
  const onSelect = (option) => {
    if (Array.isArray(value)) {
      const val = value.find((ele) => ele === option) ? value.filter((ele) => ele !== option) : [...value, option];
      setValue(val, "select");
      setFocused(option);
      setInputValue("");
    }
    if (!Array.isArray(value)) {
      setValue(option, "select");
      setFocused(option);
      const val = getOptionLabel(option);
      setInputValue(val);
      prevSelectedValue.current = val;
    }
    if (!disableCloseOnSelect)
      handleClose();
    setOptions(optionsProp);
  };
  const onHover = (option) => {
    setFocused(option);
  };
  const handleKeyDown = (e) => {
    const ArrowDown = e.key === "ArrowDown";
    const ArrowUp = e.key === "ArrowUp";
    const Escape = e.key === "Escape";
    const Enter = e.key === "Enter";
    const Home = e.key === "Home";
    const End = e.key === "End";
    if (ArrowDown || ArrowUp)
      e.preventDefault();
    if (ArrowDown && !isOpen) {
      onOpen();
      return;
    }
    if (!options.length || !isOpen)
      return;
    if (Escape) {
      handleClose();
      return;
    }
    if (Enter && focused) {
      e.preventDefault();
      onSelect(focused);
      return;
    }
    if ((ArrowDown || ArrowUp) && !focused) {
      setFocused(getNext(options[0], options, getOptionDisabled));
      return;
    }
    if (ArrowDown && focused && focused !== options[options.length - 1]) {
      setFocused(getNext(options[options.indexOf(focused) + 1], options));
      return;
    }
    if (ArrowUp && focused && focused !== options[0]) {
      setFocused(getPrevious(options[options.indexOf(focused) - 1], options));
      return;
    }
    if (Home) {
      setFocused(getNext(options[0], options));
      return;
    }
    if (End) {
      setFocused(getPrevious(options[options.length - 1], options));
      return;
    }
  };
  const onClear = () => {
    inputRef.current?.focus();
    setFocused(null);
    setInputValue("");
    prevSelectedValue.current = "";
    setOptions(optionsProp);
    if (multiple) {
      setValue([], "clear");
    } else {
      setValue(null, "clear");
    }
  };
  const handleInputChange = (e) => {
    const val = e.target.value;
    setInputValue(val);
    setIsOpen(true);
    if (!val) {
      setOptions(optionsProp);
      setFocused(null);
      return;
    }
    const filter = filterOptions || ((options2, inputValue2) => options2.filter(
      (opt) => getOptionLabel(opt).toLowerCase().startsWith(inputValue2.toLowerCase())
    ));
    setOptions(filter(optionsProp, val));
  };
  const getOptionId = (ele) => getOptionKey?.(ele) ?? getOptionLabel(ele).replaceAll(" ", "-");
  const getOptionProps = (ele) => ({
    key: getOptionId(ele),
    option: ele,
    label: getOptionLabel(ele),
    onHover: () => onHover(ele),
    onSelect: () => onSelect(ele),
    id: getOptionId(ele),
    focused: ele === focused,
    selected: Array.isArray(value) ? !!value.find((val) => val === ele) : ele === value,
    disabled: getOptionDisabled?.(ele) ?? false
  });
  if (multiple && !Array.isArray(value))
    throw new import_error.CustomError(
      "Autocomplete",
      "value must be an Array when multiple is true"
    );
  if (!multiple && Array.isArray(value))
    throw new import_error.CustomError(
      "Autocomplete",
      "value must not be an Array when multiple is false"
    );
  if (!renderInput)
    throw new import_error.CustomError("Autocomplete", "`renderInput` prop is required");
  const styles = import_react2.default.useMemo(() => (0, import_theme.autocomplete)({ shadow }), [shadow]);
  const listBox = /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Popper.Floating, { sticky: "always", mainOffset: offset || 5, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "ul",
    {
      ...restProps,
      ref,
      id: lisboxId,
      className: styles.listbox({
        className: classNames?.listbox ?? className
      }),
      role: "listbox",
      "aria-multiselectable": multiple,
      "aria-roledescription": multiple ? "multiple select list" : "single select list",
      children: [
        children && options.length && !groupBy ? children({
          options: options.map(getOptionProps),
          groupedOptions: null
        }) : null,
        children && options.length && groupBy && groupedOptions ? children({
          options: null,
          groupedOptions: Object.entries(groupedOptions).reduce(
            (acc, [key, val]) => (acc[key] = val.map(getOptionProps), acc),
            {}
          )
        }) : null,
        !children && options.length && !groupBy ? options.map((ele) => {
          const props2 = getOptionProps(ele);
          return /* @__PURE__ */ (0, import_react3.createElement)(Option, { ...props2, key: props2.key });
        }) : null,
        !children && options.length && groupBy && groupedOptions ? Object.entries(groupedOptions).map(([groupHeader, grouped]) => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
          "li",
          {
            className: styles.group({
              className: classNames?.group
            }),
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "div",
                {
                  className: styles.groupHeader({
                    className: classNames?.groupHeader
                  }),
                  children: groupHeader
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "ul",
                {
                  className: styles.groupItems({
                    className: classNames?.groupItems
                  }),
                  children: grouped.map((ele) => {
                    const props2 = getOptionProps(ele);
                    return /* @__PURE__ */ (0, import_react3.createElement)(Option, { ...props2, key: props2.key });
                  })
                }
              )
            ]
          },
          groupHeader.replaceAll(" ", "-")
        )) : null,
        !loading && !options?.length ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: styles.noOptions({
              className: classNames?.noOptions
            }),
            children: noOptionsText
          }
        ) : null,
        loading && !options?.length ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: styles.loading({
              className: classNames?.noOptions
            }),
            children: loadingText
          }
        ) : null
      ]
    }
  ) });
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(Popper.Root, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Popper.Reference, { children: ({ referenceRef }) => renderInput({
      selected: Array.isArray(value) ? value.map((opt) => ({
        label: getOptionLabel(opt),
        onDelete: () => {
          setValue(
            (prev) => Array.isArray(prev) ? prev.filter((ele) => ele !== opt) : null,
            "remove"
          );
        }
      })) : null,
      onBlur: handleClose,
      isOpen,
      multiple: !!multiple,
      onOpen,
      clearButtonProps: {
        onClear,
        onPointerDown: (e) => e.preventDefault(),
        tabIndex: -1,
        "aria-label": "clear value button"
      },
      showClearButton: disableClearable ? false : Array.isArray(value) ? !!value.length : !!value,
      popperReferenceRef: (0, import_react_utils2.mergeRefs)(referenceRef, popperReferenceRef),
      inputRef,
      value,
      inputValue,
      onChange: handleInputChange,
      disabled: !!disabled,
      onKeyDown: handleKeyDown,
      ariaProps: {
        role: "combobox",
        "aria-expanded": isOpen,
        "aria-controls": lisboxId,
        "aria-haspopup": "listbox",
        "aria-autocomplete": "list",
        "aria-activedescendant": isOpen && focused ? getOptionId(focused) : void 0
      }
    }) }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(StylesProvider, { ...styles, children: isOpen ? portal ? (0, import_react_dom.createPortal)(listBox, document.body) : listBox : null })
  ] });
});
AutocompleteImp.displayName = "webbo-ui." + Autocomplete_Name;
var Autocomplete = AutocompleteImp;
var getNext = (current, items, isOptionDisabled) => {
  if (!isOptionDisabled)
    return current;
  for (let i = items.indexOf(current); i <= items.length; i++) {
    const option = items[i];
    if (!isOptionDisabled(option))
      return option;
  }
  return current;
};
var getPrevious = (current, items, isOptionDisabled) => {
  if (!isOptionDisabled)
    return current;
  for (let i = items.indexOf(current) - 1; i > 0; i--) {
    const option = items[i];
    if (!isOptionDisabled(option))
      return option;
  }
  return current;
};

// src/map-input-props.tsx
var import_button = require("@webbo-ui/button");
var import_chip = require("@webbo-ui/chip");
var import_theme2 = require("@webbo-ui/theme");
var import_icon = require("@webbo-ui/icon");
var import_jsx_runtime3 = require("react/jsx-runtime");
var clearIcon_svg = /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_icon.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(
  "svg",
  {
    viewBox: "-2.4 -2.4 28.80 28.80",
    fill: "none",
    stroke: "currentColor",
    transform: "rotate(0)",
    children: [
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { strokeWidth: "0" }),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { strokeLinecap: "round", strokeLinejoin: "round" }),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
        "path",
        {
          d: "M20.7457 3.32851C20.3552 2.93798 19.722 2.93798 19.3315 3.32851L12.0371 10.6229L4.74275 3.32851C4.35223 2.93798 3.71906 2.93798 3.32854 3.32851C2.93801 3.71903 2.93801 4.3522 3.32854 4.74272L10.6229 12.0371L3.32856 19.3314C2.93803 19.722 2.93803 20.3551 3.32856 20.7457C3.71908 21.1362 4.35225 21.1362 4.74277 20.7457L12.0371 13.4513L19.3315 20.7457C19.722 21.1362 20.3552 21.1362 20.7457 20.7457C21.1362 20.3551 21.1362 19.722 20.7457 19.3315L13.4513 12.0371L20.7457 4.74272C21.1362 4.3522 21.1362 3.71903 20.7457 3.32851Z",
          fill: "currentColor"
        }
      ) })
    ]
  }
) });
var openIndicator_svg = /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_icon.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("svg", { viewBox: "0 0 24 24", fill: "none", children: [
  /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { strokeWidth: "0" }),
  /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { strokeLinecap: "round", strokeLinejoin: "round" }),
  /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
    "path",
    {
      fillRule: "evenodd",
      clipRule: "evenodd",
      d: "M7.00003 8.5C6.59557 8.5 6.23093 8.74364 6.07615 9.11732C5.92137 9.49099 6.00692 9.92111 6.29292 10.2071L11.2929 15.2071C11.6834 15.5976 12.3166 15.5976 12.7071 15.2071L17.7071 10.2071C17.9931 9.92111 18.0787 9.49099 17.9239 9.11732C17.7691 8.74364 17.4045 8.5 17 8.5H7.00003Z",
      fill: "currentColor"
    }
  ) })
] }) });
var mapInputProps = ({
  ariaProps,
  onOpen,
  clearButtonProps: { onClear, ...clearButtonProps },
  inputRef,
  disabled,
  onBlur,
  onChange,
  onKeyDown,
  popperReferenceRef,
  showClearButton,
  selected,
  isOpen,
  multiple,
  inputValue
}) => {
  const styles = (0, import_theme2.autocompleteInput)({ multiple });
  return {
    classNames: {
      inputWrapper: styles.inputWrapper(),
      input: styles.input(),
      startContent: styles.startContent(),
      endContent: styles.endContent()
    },
    startContent: selected?.map((opt, i) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
      import_chip.Chip,
      {
        color: "default",
        variant: "border",
        label: opt.label,
        onDelete: opt.onDelete,
        "aria-label": `selected ${opt.label}`,
        deleteIconA11yLabel: `remove ${opt.label}`,
        excludeFromTabOrder: true
      },
      i
    )),
    endContent: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(import_jsx_runtime3.Fragment, { children: [
      showClearButton && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
        import_button.Button,
        {
          ...clearButtonProps,
          isIconOnly: true,
          variant: "text",
          onPress: onClear,
          size: "sm",
          classNames: { base: styles.clearButton() },
          children: clearIcon_svg
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
        "span",
        {
          style: { rotate: isOpen ? "180deg" : "0deg" },
          className: styles.openIndecator(),
          children: openIndicator_svg
        }
      )
    ] }),
    inputWrapperProps: {
      // @ts-expect-error ----
      "data-chips": !!selected?.length,
      onPointerDown: (e) => {
        e.preventDefault();
        if (e.target.closest("button") || e.button !== 0 || disabled)
          return;
        inputRef.current?.focus();
        onOpen();
      }
    },
    ref: popperReferenceRef,
    inputRef,
    onBlur,
    value: inputValue,
    onChange,
    disabled,
    onKeyDown,
    ...ariaProps
  };
};

// src/index.ts
var Autocomplete2 = Autocomplete;
var Option2 = Option;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Autocomplete,
  Option,
  mapInputProps
});
