"use client";
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/map-input-props.tsx
var map_input_props_exports = {};
__export(map_input_props_exports, {
  mapInputProps: () => mapInputProps
});
module.exports = __toCommonJS(map_input_props_exports);
var import_button = require("@webbo-ui/button");
var import_chip = require("@webbo-ui/chip");
var import_theme = require("@webbo-ui/theme");
var import_icon = require("@webbo-ui/icon");
var import_jsx_runtime = require("react/jsx-runtime");
var clearIcon_svg = /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icon.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
  "svg",
  {
    viewBox: "-2.4 -2.4 28.80 28.80",
    fill: "none",
    stroke: "currentColor",
    transform: "rotate(0)",
    children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { strokeWidth: "0" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { strokeLinecap: "round", strokeLinejoin: "round" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "path",
        {
          d: "M20.7457 3.32851C20.3552 2.93798 19.722 2.93798 19.3315 3.32851L12.0371 10.6229L4.74275 3.32851C4.35223 2.93798 3.71906 2.93798 3.32854 3.32851C2.93801 3.71903 2.93801 4.3522 3.32854 4.74272L10.6229 12.0371L3.32856 19.3314C2.93803 19.722 2.93803 20.3551 3.32856 20.7457C3.71908 21.1362 4.35225 21.1362 4.74277 20.7457L12.0371 13.4513L19.3315 20.7457C19.722 21.1362 20.3552 21.1362 20.7457 20.7457C21.1362 20.3551 21.1362 19.722 20.7457 19.3315L13.4513 12.0371L20.7457 4.74272C21.1362 4.3522 21.1362 3.71903 20.7457 3.32851Z",
          fill: "currentColor"
        }
      ) })
    ]
  }
) });
var openIndicator_svg = /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icon.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("svg", { viewBox: "0 0 24 24", fill: "none", children: [
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { strokeWidth: "0" }),
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { strokeLinecap: "round", strokeLinejoin: "round" }),
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "path",
    {
      fillRule: "evenodd",
      clipRule: "evenodd",
      d: "M7.00003 8.5C6.59557 8.5 6.23093 8.74364 6.07615 9.11732C5.92137 9.49099 6.00692 9.92111 6.29292 10.2071L11.2929 15.2071C11.6834 15.5976 12.3166 15.5976 12.7071 15.2071L17.7071 10.2071C17.9931 9.92111 18.0787 9.49099 17.9239 9.11732C17.7691 8.74364 17.4045 8.5 17 8.5H7.00003Z",
      fill: "currentColor"
    }
  ) })
] }) });
var mapInputProps = ({
  ariaProps,
  onOpen,
  clearButtonProps: { onClear, ...clearButtonProps },
  inputRef,
  disabled,
  onBlur,
  onChange,
  onKeyDown,
  popperReferenceRef,
  showClearButton,
  selected,
  isOpen,
  multiple,
  inputValue
}) => {
  const styles = (0, import_theme.autocompleteInput)({ multiple });
  return {
    classNames: {
      inputWrapper: styles.inputWrapper(),
      input: styles.input(),
      startContent: styles.startContent(),
      endContent: styles.endContent()
    },
    startContent: selected?.map((opt, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_chip.Chip,
      {
        color: "default",
        variant: "border",
        label: opt.label,
        onDelete: opt.onDelete,
        "aria-label": `selected ${opt.label}`,
        deleteIconA11yLabel: `remove ${opt.label}`,
        excludeFromTabOrder: true
      },
      i
    )),
    endContent: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      showClearButton && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_button.Button,
        {
          ...clearButtonProps,
          isIconOnly: true,
          variant: "text",
          onPress: onClear,
          size: "sm",
          classNames: { base: styles.clearButton() },
          children: clearIcon_svg
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "span",
        {
          style: { rotate: isOpen ? "180deg" : "0deg" },
          className: styles.openIndecator(),
          children: openIndicator_svg
        }
      )
    ] }),
    inputWrapperProps: {
      // @ts-expect-error ----
      "data-chips": !!selected?.length,
      onPointerDown: (e) => {
        e.preventDefault();
        if (e.target.closest("button") || e.button !== 0 || disabled)
          return;
        inputRef.current?.focus();
        onOpen();
      }
    },
    ref: popperReferenceRef,
    inputRef,
    onBlur,
    value: inputValue,
    onChange,
    disabled,
    onKeyDown,
    ...ariaProps
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  mapInputProps
});
